%LuLu's cutest code for the sythesizer  OPA!!!
clear all;
close all;
clc;
        c   = 3e8;                                                         %Speed of light im m/s
        eps = 8.85e-12;                                                    %Free space permittivity
%**********************************************
%define input pulses properties
%*********************************************
        waist=1e-3;                                                        %waist of the beam
        F_p=5e-4./(pi*waist^2/2);                                         %pulse fluence J/m^2
        tau_fwhm_p= 150e-15;                                               %FWHM pump duratio
        tau_p = tau_fwhm_p/(2*sqrt(log(2)));                               %exp(-t^2/tau^2) 
        L_eff     =5e-3;                                                   %distance of interest                               
        z0        = 0:0.2e-5:L_eff;                                        %1D calculation step size of space
        dz=z0(2)-z0(1);                                                    %step size in space

        
%************************************************
%define frequency and time arries
%***********************************************
        deltaw = 0.01;%0.01                                                %d_omega, the frequency step size
        w_max= 80;                                                         %frequency steps number
        omega_0_p=2*pi*c/(800*1e-9);                                       %Central angular frequency of pulse
        f_0_p=omega_0_p/(2*pi);                                            %Central frequency of pulse                                           
         
        omega_p= omega_0_p + 2*pi*(-w_max:deltaw:w_max)*1e12;         
        omega_p=omega_p';
        f_p=omega_p./(2*pi);
                                                  
        dw = omega_p(2)-omega_p(1);
        t= linspace(-2*pi/(2*dw),2*pi/(2*dw),length(omega_p))';            %time array is related to frequency array due to the fourier transform
        dt=t(2)-t(1);

        
%************************************************
%define refractive index
%***********************************************
[n_p,~]=BBO_n(1e6*c./f_p);                                                 %choose the ordinary refractive index as an example
%n_p=n_p*0+3;
n2_0 =4e-20;                                                             %nonlinear refractive index
%n2_0=0;

% Peak field amplitude in time
e0 = sqrt(2*sqrt(2)*F_p/(sqrt(pi)*c*eps*BBO_n(1e6*c./f_0_p)*(tau_p)));     %electric field e0*exp(-t^2/tau^2) flux propotional to int e0^2*exp(-2t^2/tau^2)dt
% define electric field in frequency
e_f=tau_p*e0*sqrt(pi).*exp(-(omega_p-omega_0_p).^2*tau_p^2/4);
e_t_0=fftshift(ifft(ifftshift(e_f))).*length(omega_p)*(dw/(2*pi));

% figure
% plot(f_p,e_f)
% figure
% plot(t,e0,'*')
% hold on
% plot(t,e_t_0)


k_p =omega_p.*n_p/c;
u_p  =  e_f;
e_p =  u_p;
%nice coding habit to set array to zeros 
%energy_p=zeros((length(z0)-1),1);
e_pt=zeros(length(omega_p),1); 

%%propagation
for m = 1 :length(z0)-1

l_p_1=dz*pol_p_1d(n2_0,u_p,k_p,f_p,n_p,z0(m));
l_p_2=dz*pol_p_1d(n2_0,u_p+0.5*l_p_1,k_p,f_p,n_p,z0(m)+0.5*dz);
l_p_3=dz*pol_p_1d(n2_0,u_p+0.5*l_p_2,k_p,f_p,n_p,z0(m)+0.5*dz);
l_p_4=dz*pol_p_1d(n2_0,u_p+l_p_3,k_p,f_p,n_p,z0(m)+dz);


u_p = u_p + (l_p_1+2*l_p_2+2*l_p_3+l_p_4)/6;   
e_p = u_p.*exp(-1i*k_p*(z0(m+1)));
e_pt=fftshift(ifft(ifftshift(e_p))).*length(omega_p)*dw/(2*pi);
    
pow_p(m)=0.5*c*eps*trapz(f_p,abs(u_p).^2.*n_p);                            %energy conservation 
end

    
%% Plotting the results
figure
plot(z0(1:end-1)/1e-3,pow_p,'LineWidth',6); xlabel('\bf{z(mm)}');ylabel('Fluence');title('Conversion of energy');
ylim([F_p-10 F_p+10])
figure
plot(f_p/1e12,abs(e_p),'LineWidth',6); xlabel('Frequency (THz)');ylabel('|E|');title('Output Envelope of Pulse in frequency');
hold on 
plot(f_p/1e12,abs(e_p),'LineWidth',6); xlabel('Frequency (THz)');ylabel('|E|');title('Output Envelope of Pulse in frequency');
xlim([330 430])
figure
plot(t/1e-12,abs(e_pt),'LineWidth',6);xlabel('Time (ps)');ylabel('|E|');title('Output Envelope of Pulse in time');
xlim([t(find(abs(e_pt)==max(abs(e_pt)))-40)/1e-12 t(find(abs(e_pt)==max(abs(e_pt)))+40)/1e-12])
figure
plot(t,e_t_0)
hold on
plot(t-2.8075e-11,abs((e_pt)))





 